/**
 *  \file IMP/algebra.h   \brief Include all the headers
 *
 *  Copyright 2007-2010 IMP Inventors. All rights reserved.
 *
 */

#ifndef IMPALGEBRA_H
#define IMPALGEBRA_H

#include <IMP/algebra/BoundingBoxD.h>
#include <IMP/algebra/Cone3D.h>
#include <IMP/algebra/Cylinder3D.h>
#include <IMP/algebra/Ellipsoid3D.h>
#include <IMP/algebra/Grid3D.h>
#include <IMP/algebra/LinearFit.h>
#include <IMP/algebra/Matrix2D.h>
#include <IMP/algebra/Matrix3D.h>
#include <IMP/algebra/MultiArray.h>
#include <IMP/algebra/ParabolicFit.h>
#include <IMP/algebra/Plane3D.h>
#include <IMP/algebra/Rotation2D.h>
#include <IMP/algebra/Rotation3D.h>
#include <IMP/algebra/Segment3D.h>
#include <IMP/algebra/Sphere3D.h>
#include <IMP/algebra/SphereD.h>
#include <IMP/algebra/SpherePatch3D.h>
#include <IMP/algebra/SphericalVector3D.h>
#include <IMP/algebra/Transformation2D.h>
#include <IMP/algebra/Transformation3D.h>
#include <IMP/algebra/Vector2D.h>
#include <IMP/algebra/Vector3D.h>
#include <IMP/algebra/VectorD.h>
#include <IMP/algebra/algebra_config.h>
#include <IMP/algebra/algebra_macros.h>
#include <IMP/algebra/eigen_analysis.h>
#include <IMP/algebra/endian.h>
#include <IMP/algebra/geometric_alignment.h>
#include <IMP/algebra/grid_range_D.h>
#include <IMP/algebra/interpolation.h>
#include <IMP/algebra/io.h>
#include <IMP/algebra/shortest_segment.h>
#include <IMP/algebra/utility.h>
#include <IMP/algebra/vector_generators.h>
#include <IMP/algebra/vector_search.h>

#endif  /* IMPALGEBRA_H */
